'CopyObject & CopyObjectTree
Strict
Framework brl.standardio
Import Thunder.ObjectEx

Type U
	Field z
EndType

Type T
	Field name:String
	Field x,y
	Field _pi#
	Field _self:T, _new:T
	Field _other:U
	
EndType

Global x:T, y:T

x = New T

ResetX

Print "Using CopyObject to Copy X into Y..."
y = T(CopyObject(x))

Status

Print
Print "Now only modifying Values in Y..."

y.name = "Y"			' Will NOT change X
y.x :+ 50				' Will NOT change X
y.y :+ 50				' Will NOT change X
y._pi :* 2				' Will NOT change X
y._self.x :+ 50			' Will change X because y._self points to x
y._new.name = "YY"		' Will change X because y._new is same as x._new
y._other.z = 666		' Will change X because y._other is same as x._other

Status

ResetX

Print "Using CopyObjectTree to Copy X into Y..."
y = T(CopyObjectTree(x))

Status

Print
Print "Now only modifying Values in Y..."

' X will NOT be changed here
y.name = "Y"
y.x :+ 50
y.y :+ 50
y._pi :* 2
y._self.x :+ 50
y._new.name = "YY"
y._other.z = 666

Status

End

Function ResetX()
	x.name = "X"
	x.x = 10
	x.y = 20
	x._pi = 3.14
	x._self = x
	x._new = New T
	x._other = New U
	x._other.z = 42
EndFunction

Function Status()
	Print
	Print "Type~t~tX~t~tY"
	Print "Name:~t~t"+x.name+"~t~t"+y.name
	Print "X:~t~t"+x.x+"~t~t"+y.x
	Print "Y:~t~t"+x.y+"~t~t"+y.y
	Print "Pi:~t~t"+String.FromFloat(x._pi)[..4]+"~t~t"+String.FromFloat(y._pi)[..4]
	Print "_self.name:~t"+x._self.name+"~t~t"+y._self.name
	Print "_new.name:~t"+x._new.name+"~t~t"+y._new.name
	Print "_other.z:~t"+x._other.z+"~t~t"+y._other.z
EndFunction
