' "Reverse Engineering" some Types
Strict
Framework brl.blitz
Import brl.pixmap
Import Thunder.ObjectEx

Local TStream_oex:ObjectEx
Local TStreamSuper_oex:ObjectEx

summary ObjectEx.Create(New TPixmap)
summary ObjectEx.Create(New ObjectEx)

TStream_oex = ObjectEx.Create(New TStream)
TStreamSuper_oex = TStream_oex.SuperObjectEx()

summary TStreamSuper_oex
summary TStream_oex, TStreamSuper_oex.name

End

Function summary(oex:ObjectEx, ext:String = "")
	Local i:ObjectExIdent, p, typ:String
	Local list:ObjectExIdent[]
	
	WriteStdout "~nType "+oex.name
	If ext Then WriteStdout " Extends "+ext
	WriteStdout "~n~n"
	
	
	For i = EachIn oex.Fields()
		
		WriteStdout "~tField "+i.name+typetag_convert(i.typ)+"~n"
		
	Next
	
	WriteStdout "~n"
	
	For i = EachIn oex.Methods()
		
		p = 0
		WriteStdout "~tMethod "+i.name
		typ = i.typ[i.typ.find(")")+1..]
		
		i.typ = i.typ[1..i.typ.find(")")]
		WriteStdout typetag_convert(typ)
		WriteStdout "("
		
		Repeat
		
			typ = i.typ[..i.typ.find(",")]
			If Not typ Then Exit
			i.typ = i.typ[i.typ.find(",")+1..]
			
			WriteStdout Chr(Asc"a" + p)+typetag_convert(typ)+", "
			p:+1
		Forever
		typ = i.typ
		If typ Then
			WriteStdout Chr(Asc"a" + p)+typetag_convert(typ)
		EndIf
		
		WriteStdout ")~n"
	Next
	
	WriteStdout "~n"
	
	For i = EachIn oex.Functions()
		
		p = 0
		WriteStdout "~tFunction "+i.name
		typ = i.typ[i.typ.find(")")+1..]
		
		i.typ = i.typ[1..i.typ.find(")")]
		WriteStdout typetag_convert(typ)
		WriteStdout "("
		
		Repeat
		
			typ = i.typ[..i.typ.find(",")]
			If Not typ Then Exit
			i.typ = i.typ[i.typ.find(",")+1..]
			
			WriteStdout Chr(Asc"a" + p)+typetag_convert(typ)+", "
			p:+1
		Forever
		typ = i.typ
		If typ Then
			WriteStdout Chr(Asc"a" + p)+typetag_convert(typ)
		EndIf
		
		WriteStdout ")~n"
	Next
	
	WriteStdout "EndType~n~n"
EndFunction


Function typetag_convert:String(tag:String)
	Local r:String, p, brackets:String
	
	If tag.startswith("[") Then
		brackets = tag[..tag.findlast("]")+1]
		tag = tag[tag.findlast("]")+1..]
	EndIf
		
	If tag.startswith("*") Then
		p = tag.findlast("*")+1
		tag = tag[p..]
	EndIf
		
	Select tag
	Case "i"
		r :+ ":Int"
	Case "b"
		r :+ ":Byte"
	Case "s"
		r :+ ":Short"
	Case "l"
		r :+ ":Long"
	Case "f"
		r :+ ":Float"
	Case "d"
		r :+ ":Double"
	Case "$"
		r :+ ":String"
	Default
		If tag.startswith(":") Then
			r :+ tag
		Else
			' ???
		EndIf
	EndSelect
	
	For p = p Until 0 Step -1
		r :+ " Ptr"
	Next
	
	r:+brackets

	Return r	
EndFunction

